// gcc -std=gnu11 -Wall -o stralloc stralloc.c -I /usr/local/diet/include/ -lowfat -L/usr/local/diet/lib

#include <stralloc.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <strings.h>
#include <unistd.h>

const int BUFFER_SIZE = 8192;
const char* path = "./test.txt";

int readline(FILE* fp, stralloc* sa) {
	if (!stralloc_copys(sa, "")) return 0;
	for(;;) {
		if (!stralloc_readyplus(sa, 1)) return 0;
		if (fread(sa->s + sa->len, sizeof(char), 1, fp) <= 0) return 0;
		if (sa->s[sa->len] == '\n') break;
		++sa->len;
	}
	return 1;
}

int main(int argc, char** argv){
        stralloc string = {0};
        FILE* fp = fopen(path, "r");
      
	while(readline(fp, &string)){       
           printf("%s",string.s);
           string.s=0;
           string.len=0;
           string.a=0;
	}	
 
        fclose(fp);

	return 0;
}
